hdu 1535 Invitation Cards 大年初一首A 一次正向SPFA+一次逆向SPFA

Invitation Cards

Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)

Total Submission(s): 2311    Accepted Submission(s): 1125

Problem Description

In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards
with all the necessary information and with the programme. A lot of students were hired to distribute these invitations among the people. Each student volunteer has assigned exactly one bus stop and he or she stays there the whole day and gives invitation
to people travelling by bus. A special course was taken where students learned how to influence people and what is the difference between influencing and robbery.

The transport system is very special: all lines are unidirectional and connect exactly two stops. Buses leave the originating stop with passangers each half an hour. After reaching the destination stop they return empty to the originating stop, where they wait
until the next full half an hour, e.g. X:00 or X:30, where ‘X‘ denotes the hour. The fee for transport between two stops is given by special tables and is payable on the spot. The lines are planned in such a way, that each round trip (i.e. a journey starting
and finishing at the same stop) passes through a Central Checkpoint Stop (CCS) where each passenger has to pass a thorough check including body scan.

All the ACM student members leave the CCS each morning. Each volunteer is to move to one predetermined stop to invite passengers. There are as many volunteers as stops. At the end of the day, all students travel back to CCS. You are to write a computer program
that helps ACM to minimize the amount of money to pay every day for the transport of their employees.

Input

The input consists of N cases. The first line of the input contains only positive integer N. Then follow the cases. Each case begins with a line containing exactly two integers P and Q, 1 <= P,Q <= 1000000. P is the number of stops
including CCS and Q the number of bus lines. Then there are Q lines, each describing one bus line. Each of the lines contains exactly three numbers - the originating stop, the destination stop and the price. The CCS is designated by number 1. Prices are positive
integers the sum of which is smaller than 1000000000. You can also assume it is always possible to get from any stop to any other stop.

Output

For each case, print one line containing the minimum amount of money to be paid each day by ACM for the travel costs of its volunteers.

Sample Input

2
2 2
1 2 13
2 1 33
4 6
1 2 10
2 1 60
1 3 20
3 4 10
2 4 5
4 1 50

Sample Output

46
210

先是从1到其他结点来一次SPFA。然后是其他点分别到1来一次SPFA,可想而知,肯定超时,我们可以转换思路,由于终点都是1,那我们在反向建一个图,然后从1在到其他结点来一最短路,不就解决了吗

第一次用邻接表,代码写的比较渣。见谅:

#include <cstdio>
#include <queue>
#include <cstring>
#define MAX 1000100
#define INF 1500000000
using namespace std ;

struct Node{
	int to ;
	int w;
	int next ;
}edge[MAX],rev[MAX];

int head[MAX] ,revHead[MAX], cnt[MAX] , dis[MAX] ;
bool visited[MAX];

void init(int p , int q)
{
	memset(head,-1,sizeof(int)*(p+10)) ;
	memset(revHead,-1,sizeof(int)*(p+10)) ;
	for(int i = 1 ; i <= q ; ++i)
	{
		int x , y , w ;
		scanf("%d%d%d",&x,&y,&w) ;
		edge[i].to = y;
		edge[i].w = w ;
		edge[i].next = head[x];
		head[x] = i ;

		rev[i].to = x ;
		rev[i].w = w ;
		rev[i].next = revHead[y] ;
		revHead[y] = i ;
	}
}

bool SPFA(int h[] , Node e[], int s , int n)
{
	for(int i = 0 ; i <= n ; ++i )
	{
		dis[i] = INF;
		visited[i] = false ;
		cnt[i] = 0 ;
	}
	dis[s] = 0 ;
	visited[s] = true ;
	queue<int> que ;
	que.push(s) ;
	while(!que.empty())
	{
		int index = que.front() ;
		que.pop() ;
		++cnt[index] ;
		visited[index] = false ;
		if(cnt[index]>n)
		{
			return false ;
		}
		for(int i = h[index] ; i != -1 ; i = e[i].next)
		{
			if(dis[e[i].to]>dis[index]+e[i].w)
			{
				dis[e[i].to] = dis[index]+e[i].w ;
				if(!visited[e[i].to])
				{
					que.push(e[i].to);
					visited[e[i].to] = true ;
				}
			}
		}
	}
	return true ;
}

int main()
{
	int p,q,n;
	scanf("%d",&n);
	while(n--)
	{
		scanf("%d%d",&p,&q);
		init(p,q);
		SPFA(head,edge,1,p);
		int sum = 0 ;
		for(int i = 2 ; i <= p ; ++i)
		{
			sum += dis[i];
		}
		SPFA(revHead,rev,1,p) ;
		for(int i = 2 ; i <= p ; ++i)
		{
			sum += dis[i];
		}
		printf("%d\n",sum) ;
	}
	return 0 ;
}

与君共勉

时间: 2024-10-28 23:51:54

hdu 1535 Invitation Cards 大年初一首A 一次正向SPFA+一次逆向SPFA的相关文章

HDU 1535 Invitation Cards (POJ 1511)

两次SPFA.求 来 和 回 的最短路之和. 用Dijkstra+邻接矩阵确实好写+方便交换,但是这个有1000000个点,矩阵开不了. d1[]为 1~N 的最短路. 将所有边的 邻点 交换. d2[] 为 1~N 的最短路. 所有相加为 所要答案. 忧伤的是用SPFA  "HDU 1535"  AC了,但是POJ 一样的题 "POJ 1511" 就WA了. 然后强迫症犯了,不停的去测试. 题意中找到一句关键话 :Prices are positive integ

hdu 1535 Invitation Cards(有向图的来回最短路,要反向建图)

题目: 链接:点击打开链接 题意: 给一个图,求1到各点和各点到1最短路. 思路: 先spfa,然后反向建图,在spfa就行了. 代码: #include <iostream> #include <cstdio> #include <queue> #include <cstring> using namespace std; #define INF 100000000 const int N = 1000010; struct node{ int u,v,w

HDU 1535 Invitation Cards (最短路,附SLF优化SPFA)

题目: http://acm.hdu.edu.cn/showproblem.php?pid=1535 题意: 有向图,求点1到点2-n的最短距离之和以及点2-n到点1的最短距离之和 方法: 1.跑1为原点的最短路 2.反向建图(把有向图的边反向,(u,v,w)变成(v,u,w)),跑1为原点的最短路 3.将两者距离之和加和即可(注意用 long long ,int会溢出) 1 void input() 2 { 3 scanf("%d%d", &n, &m); 4 g1.

hdu 1535 Invitation Cards(SPFA)

Invitation Cards Time Limit : 10000/5000ms (Java/Other)   Memory Limit : 65536/65536K (Java/Other) Total Submission(s) : 28   Accepted Submission(s) : 14 Font: Times New Roman | Verdana | Georgia Font Size: ← → Problem Description In the age of telev

HDU - 1535 Invitation Cards 前向星SPFA

Invitation Cards In the age of television, not many people attend theater performances. Antique Comedians of Malidinesia are aware of this fact. They want to propagate theater and, most of all, Antique Comedies. They have printed invitation cards wit

hdu 1535 Invitation Cards

#include<stdio.h> #include<string.h> #include<algorithm> #include<queue> using namespace std; const int inf=1<<24; const int N=1000000+5; struct node { int to,w; node* next; }; node* edge[N]; node* reedge[N]; int n,m,x,dist[N

HDU ACM 1535 Invitation Cards单点到多源最短路-&gt;SPFA算法

题意:有一个起始站点,从这里送n个学生去其余的n-1个站点邀请人们去CSS,然后再返回CSS,使得总的花费最小.注意每次只能送一个,返回时每次也只能送一个,而且每条路是单向的. 分析:这相当于一个有向图,我们只需两次调用SPFA算法即可,第一次求出初始站点(在这里是1)到其它所有站点的最小花费,然后相加:第二次将图反向建立,即所有的边反向,再求出初始站点(这里是1)到其它站点的最小费用,之后相加,第二步的图反向后按照第一次的求法就相当于从其它所有点到初始点的最小距离,因为算法只能求单点到多点而不

hdu 1513 Invitation Cards【spfa翻转边】

题目链接:http://acm.acmcoder.com/showproblem.php?pid=1535 题意:有向图,求源点到各个点最短路径和+各个点到源点最短路径和. spfa求单源最短路径,求各个点到源点最短路径翻转边. #include <iostream> #include <stdio.h> #include <string.h> #include <algorithm> #include <math.h> #include <

HDU 1535 &amp;&amp; POJ 1511 Invitation Cards (SPFA 模板 + 反向建图)

Invitation Cards HDU: Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) POJ: Time Limit: 8000 MS     Memory Limit: 262144 K       Problem Description In the age of television, not many people attend theater performa